header "More On Locales"

(*<*)
theory Demo2 = Demo14:
(*>*)

locale agroup = group +
  assumes com: "x \<cdot> y = y \<cdot> x"

(*<*)
lemma (in agroup) True
(*>*)
txt {*
  We are now in the @{text agroup} context where assumption
  @{thm [source] com}: @{thm com [no_vars]} is visible without
  any further premises.

  All inherited and proved theorems of the @{text group} context
  are available as well:

  @{thm assoc [no_vars]}

  @{thm l_one [no_vars]}

  @{thm l_inv [no_vars]}

  @{thm r_one [no_vars]}

  @{thm r_inv [no_vars]}
  
  etc.
*}
(*<*)
oops
(*>*)

text {*
  Outside the context, these theorems would look like this.
  (for fun we replace @{text "\<Longrightarrow>"} by @{text "\<longrightarrow>"} in \LaTeX).

  \renewcommand{\isasymLongrightarrow}{\isasymlongrightarrow}
  
  @{thm agroup.com [no_vars]} 

  @{thm semi.assoc [no_vars]}

  @{thm group.l_one [no_vars]}

  @{thm group.l_inv [no_vars]}

  @{thm group.r_one [no_vars]}

  @{thm group.r_inv [no_vars]}
*}

text {* Changing existing output syntax: *}

syntax (latex output)
  Cons :: "'a \<Rightarrow> 'a list \<Rightarrow> 'a list" ("_\<cdot>/_" [66,65] 65)

text {*
  Now existing function definitios look different:  
  @{thm [display] map.simps [no_vars]}

  \bigskip

  Creating new symbols and changing output syntax:
*}

text_raw {* \newcommand{\isasymnotex}{\isamath{\neg\exists}} *}

syntax (latex)
  notEx         :: "('a => bool) => bool"  (binder "\<notex>" 10)
translations
  "\<notex>x. P" == "\<not>(\<exists>x. P)"

lemma "(\<forall>x. \<not>P x) = (\<notex>x. P x)" by blast

(*<*)
end
(*>*)